io.stdout:setvbuf('no')

local Lander = {}
Lander.x = 0
Lander.y = 0
Lander.angle = love.math.random(0,359)
Lander.vx = 0
Lander.vy = 0
Lander.speed = love.math.random(0,1)
Lander.engineOn = false
Lander.imgEngine = love.graphics.newImage("/images/engine.png")
Lander.img = love.graphics.newImage("/images/ship.png")

gintLandY = 550

function shipMovement(dt)
  if love.keyboard.isDown("right") then
      Lander.angle = Lander.angle + (90 * dt)
      if Lander.angle > 360 then Lander.angle = 0 end
  end   
  if love.keyboard.isDown("left") then
      Lander.angle = Lander.angle - (90 * dt)
      if Lander.angle < 0 then Lander.angle = 360 end
  end
  if love.keyboard.isDown("up") then
    Lander.engineOn = true
    local angle_radian = math.rad(Lander.angle)
    local force_x = math.cos(angle_radian) * (Lander.speed * dt)
    local force_y = math.sin(angle_radian) * (Lander.speed * dt)
	
-- this will sometimes be zero meaning zero force meaning the lander never slows down
print(force_y)
--

    Lander.vx = Lander.vx + force_x
    Lander.vy = Lander.vy + force_y

  else
    Lander.engineOn = false
  end
  Lander.vy = Lander.vy + (0.6 * dt)

  if math.abs(Lander.vx) > 1 then
    if Lander.vx > 0 then
      Lander.vx = 1
    else 
      Lander.vx = -1
    end
  end

if Lander.vy > 1 then
  Lander.vy = 1
elseif Lander.vy < -1 then
  Lander.vy = -1
end

end
    
function velocity(dt)
      Lander.x = Lander.x + Lander.vx 
      Lander.y = Lander.y + Lander.vy
  end

function love.load()
    gintScreenWidth = love.graphics.getWidth()
    gintScreenHeight = love.graphics.getHeight()
    
    Lander.x = gintScreenWidth/2
    Lander.y = gintScreenHeight/2
end

function checkiflanded()
	if Lander.y >= gintLandY - 10 then
		gbolGameOver = true
	
		if Lander.vy > 0.2 then
			print("dead")
		elseif Lander.vy <= 0.2 then
			print("win")
		end
	end


end

function love.draw()
    love.graphics.draw(Lander.img, Lander.x, Lander.y, 
      math.rad(Lander.angle), 1, 1, Lander.img:getWidth()/2, Lander.img:getHeight()/2)
    
  if Lander.engineOn == true then
    love.graphics.draw(Lander.imgEngine, Lander.x, Lander.y, 
      math.rad(Lander.angle), 1, 1, Lander.imgEngine:getWidth()/2, Lander.imgEngine:getHeight()/2)
  end
  myPrint()
  
  love.graphics.line(0,gintLandY, gintScreenWidth,gintLandY)
  
end

function love.update(dt)
	if not gbolGameOver then
		velocity(dt)
		shipMovement(dt)
		checkiflanded()
	end
end

function myPrint()
    local sDebug = "Angle:"
    sDebug = sDebug.." angle= "..tostring(Lander.angle)
    sDebug = sDebug.." vx= "..tostring(Lander.vx);
    sDebug = sDebug.." vy= "..tostring(Lander.vy);
    love.graphics.print(sDebug, 0, 0)
    
end

